﻿using System;
using System.Runtime.InteropServices;

namespace ScanDemo
{
    public enum ConfigSettings : int
    {
        CV_CAL_STOPSCAN = 0,
        CV_CAL_SET_RESO = 4,
        CV_CAL_STARTSCAN = 6,
        CV_CAL_SET_LIGHT = 8,
        CV_CAL_SET_DEV = 10,
        CV_CAL_FORCESCAN = 11,
        CV_CAL_PAPER = 24
    }

    public enum Resolutions : int
    {
        EACRmFULL2 = 2 //Full res in black and white.
    }

    public enum DeviceCode
    {
        EDEV200A4_1728 = 1,
    }

    public struct CyberImg
    {
        public IntPtr pIm;
        public IntPtr pCoef;
        public IntPtr pGamma;
        public IntPtr pTDens;
        public IntPtr pTSwap;
        //public IntPtr WinBITMAP;
        //public IntPtr WinHDC;
        public int lTime;
        public short wWidBy;
        public short wWid;
        public short wHei;
        public short wNoClr;
        public byte bPlanes;
        public byte bType;
        public byte bRet;
    }

    class CyberCs
    {

        
        [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
        public delegate void ScanDataCallback(ref CyberImg data);

        [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
        public delegate bool ScanPartDataCallback(ref CyberImg data);

        [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
        public delegate void ErrorReportCallback(int error, int type);

        

        [DllImport("CyberSc.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern int ScInit(ScanDataCallback fpFinScanning, 
            ErrorReportCallback fpError);

        [DllImport("CyberSC.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern int ScSetupPartScan([In, Out]int[] steps, 
            int numSteps, ScanPartDataCallback fpPartScan);

        [DllImport("CyberSc.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern int ScSCalibrate(ConfigSettings step, int param);

        [DllImport("CyberSc.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern void ScRejectPaper();

    }
}
